#ifndef INTERACTABLEDECORATIVEOBJECT_HPP_INCLUDED
#define INTERACTABLEDECORATIVEOBJECT_HPP_INCLUDED

#include "../../Core/Classes/DecorativeObject.hpp"
#include "../../Core/Classes/ObjectInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Point.hpp"
#include "../../Core/Types/Box.hpp"
#include "../../Core/Types/Convex.hpp"
#include "../../Core/Input.hpp"
#include <cstdint>

namespace Interactable
{
    class DecorativeObject : public Internal::DecorativeObject
    {
        public:
            DecorativeObject(const Internal::DecorativeObject& D);
            DecorativeObject(const DecorativeObject& D);

            std::int32_t GetID() const;
            std::string GetName() const;
            Internal::ObjectInfo GetInfo() const;

            Box GetBox() const;
            Point GetPoint() const;
            Convex GetConvex() const;
            std::vector<Point> GetModel() const;

            double GetVisibility() const;
            Tile GetTile() const;

            bool Interact(const Button& B = BUTTON_LEFT) const;
            bool Interact(const std::string& Option) const;
            bool Interact(const std::vector<std::string>& Options) const;

            operator Internal::DecorativeObject() const;
    };
}


#endif // INTERACTABLEDECORATIVEOBJECT_HPP_INCLUDED
