#ifndef INTERACTABLEPLAYER_HPP_INCLUDED
#define INTERACTABLEPLAYER_HPP_INCLUDED

#include "../../Core/Classes/Player.hpp"
#include "../../Core/Classes/PlayerInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Point.hpp"
#include "../../Core/Types/Box.hpp"
#include "../../Core/Types/Convex.hpp"
#include "../../Core/Input.hpp"
#include <cstdint>

namespace Interactable
{
    class Player : public Internal::Player
    {
        public:
            Player(const Internal::Player& P);
            Player(const Player& P);

            std::string GetName() const;
            Internal::PlayerInfo GetInfo() const;

            Box GetBox() const;
            Point GetPoint() const;
            Convex GetConvex() const;

            std::vector<Point> GetModel() const;
            double GetVisibility() const;
            Tile GetTile() const;

            Internal::Character GetInteracting() const;
            bool Interacting() const;
            bool Interacting(const Internal::Character& C) const;

            bool Interact(const Button& B = BUTTON_LEFT) const;
            bool Interact(const std::string& Option) const;
            bool Interact(const std::vector<std::string>& Options) const;

            operator Internal::Player() const;
    };
}


#endif // INTERACTABLEPLAYER_HPP_INCLUDED
