#ifndef LOGOUT_HPP_INCLUDED
#define LOGOUT_HPP_INCLUDED

#include "../../../Core/Types/Box.hpp"
#include "../../../Core/Classes/World.hpp"
#include "../../../Core/Classes/Widget.hpp"
#include <cstdint>
#include <vector>

/** @addtogroup GameTabs
* @{ */
class Logout
{
    public:
        static bool IsOpen();
        static bool Open();
        static bool LogoutPlayer();

        static bool IsWorldSwitcherOpen();
        static bool OpenWorldSwitcher();

        static bool WorldSwitcherScrollTo(Internal::World World);
        static bool WorldSwitcherScrollTo(std::int32_t WorldID);

        static bool SwitchWorld(const Internal::World& World);
        static bool SwitchWorld(std::int32_t WorldID);

        static std::vector<std::uint32_t> GetFavoriteWorlds();

        static Internal::Widget GetWorldWidget(const Internal::World& World);
        static Internal::Widget GetWorldWidget(std::int32_t  WorldID);
        static Internal::Widget GetFavoriteWorldWidget(std::int32_t WorldID);
};

/** @} */

#endif // LOGOUT_HPP_INCLUDED
