#ifndef GROUNDITEMS_HPP_INCLUDED
#define GROUNDITEMS_HPP_INCLUDED

#include "../../Game/Interactable/GroundItem.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class GroundItems
{
    public:

        static std::vector<Interactable::GroundItem> GetAll();
        static std::vector<Interactable::GroundItem> GetAll(const Tile& T);
        static std::vector<Interactable::GroundItem> GetAll(std::int32_t ID);
        static std::vector<Interactable::GroundItem> GetAll(const std::string& Name);
        static std::vector<Interactable::GroundItem> GetAll(const std::vector<std::int32_t>& IDs);
        static std::vector<Interactable::GroundItem> GetAll(const std::vector<std::string>& Names);
        static std::vector<Interactable::GroundItem> GetAll(const std::function<bool (Interactable::GroundItem&)>& Filter);

        static Interactable::GroundItem Get();
        static Interactable::GroundItem Get(const Tile& T);
        static Interactable::GroundItem Get(std::int32_t ID);
        static Interactable::GroundItem Get(const std::string& Name);
        static Interactable::GroundItem Get(const std::vector<std::int32_t>& IDs);
        static Interactable::GroundItem Get(const std::vector<std::string>& Names);
        static Interactable::GroundItem Get(const std::function<bool (Interactable::GroundItem&)>& Filter);
};
/** @} */

#endif // GROUNDITEMS_HPP_INCLUDED
